unit U_BSPrtDyeInEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxCalendar, cxDropDownEdit, ComCtrls, ToolWin,
  cxGridLevel, cxGridCustomTableView, cxGridTableView, cxGridDBTableView,
  cxClasses, cxControls, cxGridCustomView, cxGrid, cxGridCustomPopupMenu,
  cxGridPopupMenu, ADODB, DBClient, cxButtonEdit, cxTextEdit, StdCtrls, ExtCtrls,
  cxLookAndFeels, cxLookAndFeelPainters, cxNavigator, dxSkinsCore,
  dxSkinsDefaultPainters, dxDateRanges, dxBarBuiltInMenu, U_BaseInput,
  System.ImageList, Vcl.ImgList, ComObj, dxScrollbarAnnotations;

type
  TfrmBSPrtDyeInEdit = class(TfrmBaseInput)
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column2: TcxGridDBColumn;
    v1SPName: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    cxGrid1Level1: TcxGridLevel;
    ToolBar1: TToolBar;
    TBAdd: TToolButton;
    TBDel: TToolButton;
    TBSave: TToolButton;
    TBClose: TToolButton;
    v1Column4: TcxGridDBColumn;
    DS_1: TDataSource;
    CDS_Sub: TClientDataSet;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    GPM_1: TcxGridPopupMenu;
    v1Column12: TcxGridDBColumn;
    v1FactoryName: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    v1SPSpec: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column2: TcxGridDBColumn;
    ToolButton1: TToolButton;
    CDS_LM: TClientDataSet;
    OpenDialog1: TOpenDialog;
    ToolButton2: TToolButton;
    Tv1Column5: TcxGridDBColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBAddClick(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure v1Column14PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1Column5PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure Tv1Column1PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure Tv1Column2PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
  private
    { Private declarations }
    function SaveCKData(): Boolean;
  public
    { Public declarations }
    FBCId, canshu3, FSTKName, FKHName: string;
  end;

var
  frmBSPrtDyeInEdit: TfrmBSPrtDyeInEdit;

implementation

uses
  U_DataLink, U_RTFun, U_ZDYHelp, U_ProductInfoSel, U_CompanySel;

{$R *.dfm}

procedure TfrmBSPrtDyeInEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmBSPrtDyeInEdit.TBAddClick(Sender: TObject);
begin
  with CDS_Sub do
  begin
    Append;
    FieldByName('IOTime').Value := Trim(FormatDateTime('yyyy-MM-dd', Now));
    FieldByName('StkCoNo').Value := '本厂仓库';
    FieldByName('StkCoName').Value := '本厂仓库';
    FieldByName('QtyUnit').Value := '';
    FieldByName('IOType').Value := '采购入库';
    Post;
  end;
//  try
//    frmProductInfoSel := TfrmProductInfoSel.Create(Application);
//    with frmProductInfoSel do
//    begin
//      FSTKName := Self.FSTKName;
//      if ShowModal = 1 then
//      begin
//        with Self.CDS_Sub do
//        begin
//          Append;
//          FieldByName('IOTime').Value := Trim(FormatDateTime('yyyy-MM-dd', Now));
//          FieldByName('StkCoNo').Value := '本厂仓库';
//          FieldByName('StkCoName').Value := '本厂仓库';
//          FieldByName('IOType').Value := '采购入库';
//          FieldByName('P_Code').Value := frmProductInfoSel.CDS_1.fieldbyname('P_Code').value;
//          FieldByName('P_Name').Value := frmProductInfoSel.CDS_1.fieldbyname('P_Name').value;
//          FieldByName('P_Spec').Value := frmProductInfoSel.CDS_1.fieldbyname('P_Spec').value;
//          FieldByName('QtyUnit').Value := frmProductInfoSel.CDS_1.fieldbyname('QtyUnit').value;
//          FieldByName('Price').Value := frmProductInfoSel.CDS_1.fieldbyname('Price').value;
//        end;
//      end;
//    end;
//  finally
//    frmProductInfoSel.Free;
//  end;

//  if CDS_Sub.IsEmpty = False then
//  begin
//    CopyAddRowCDS(CDS_Sub);
//    with CDS_Sub do
//    begin
//      Edit;
//      FieldByName('BPIOID').Value := null;
//      FieldByName('StkCoNo').Value := '本厂仓库';
//      FieldByName('StkCoName').Value := '本厂仓库';
//      post;
//    end;
//  end
//  else
//  begin
//    with CDS_Sub do
//    begin
//      Append;
//      FieldByName('IOTime').Value := Trim(FormatDateTime('yyyy-MM-dd', Now));
//      FieldByName('StkCoNo').Value := '本厂仓库';
//      FieldByName('StkCoName').Value := '本厂仓库';
//      FieldByName('QtyUnit').Value := '件';
//      Post;
//    end;
//  end;

end;

function TfrmBSPrtDyeInEdit.SaveCKData(): Boolean;
var
  Maxno, MBPIOID: string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Sub.DisableControls;
    with CDS_Sub do
    begin
      First;
      while not eof do
      begin
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Product_IO where BPIOID=''' + Trim(CDS_Sub.fieldbyname('BPIOID').AsString) + '''');
          open;
        end;
        MBPIOID := Trim(ADOQueryTemp.fieldbyname('BPIOID').AsString);
        if Trim(MBPIOID) = '' then
        begin
          if not GetLSNo(ADOQueryCmd, Maxno, 'PR', 'BS_Product_IO', 3, 1) then
            raise Exception.Create('取入库编号失败！');
        end
        else
        begin
          Maxno := Trim(MBPIOID);
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Product_IO where BPIOID=''' + Trim(Maxno) + '''');
          Open;
        end;
        with ADOQueryCmd do
        begin
          if Trim(MBPIOID) = '' then
          begin
            Append;
            FieldByName('Fillid').Value := Trim(Dcode);
            FieldByName('Filler').Value := Trim(DName);
          end
          else
          begin
            Edit;
            FieldByName('Editid').Value := Trim(Dcode);
            FieldByName('Editer').Value := Trim(DName);
            FieldByName('EditTime').Value := SGetServerDate(ADOQueryTemp);
          end;
          RTSetSaveDataCDS(ADOQueryCmd, Tv1, CDS_Sub, 'BS_Product_IO', 0);
          FieldByName('FromCoNo').Value := CDS_Sub.fieldbyname('FromCoNo').Value;
          FieldByName('StkCoNo').Value := CDS_Sub.fieldbyname('StkCoNo').Value;
          FieldByName('BPIOID').Value := Trim(Maxno);
          FieldByName('STKID').Value := Trim(Maxno);
          FieldByName('STKName').Value := FSTKName;
          FieldByName('IOFlag').Value := '入库';
          FieldByName('IOQtyFlag').Value := 1;
          Post;
        end;

//        with ADOQueryCmd do
//        begin
//          Close;
//          sql.Clear;
//          sql.Add('Update BS_Product_IO Set  StkQty=(select Sum(isnull(Qty,0)*IOQtyFlag) from BS_Product_IO A where A.STKID=BS_Product_IO.BPIOID )');
//          sql.Add(' where BPIOID=''' + Trim(Maxno) + '''');
//          ExecSQL;
//        end;
//        with ADOQueryTemp do
//        begin
//          Close;
//          sql.Clear;
//          sql.Add('select stkQty   from BS_Product_IO where BPIOID=''' + Trim(Maxno) + '''');
//          Open;
//        end;
//        if ADOQueryTemp.FieldByName('stkQty').Value < 0 then
//          raise Exception.Create('入库数量小于出库数量不能保存!');

        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add(' SELECT  isnull(P_Code,''''),isnull(P_Spec,''''), isnull(BatchNo,''''),isnull(QtyUnit,'''') ');
          SQL.Add(',sum(IOQtyFlag*qty)qty  FROM BS_Product_IO WHERE ');
          sql.Add(' isnull(stkName,'''')=''' + Trim(FstkName) + '''');
          SQL.Add('AND p_Code=' + QuotedStr(CDS_Sub.fieldbyname('p_Code').AsString));
          SQL.Add('AND P_Spec=' + QuotedStr(CDS_Sub.fieldbyname('P_Spec').AsString));
          SQL.Add('AND BatchNo=' + QuotedStr(CDS_Sub.fieldbyname('BatchNo').AsString));
          SQL.Add('AND QtyUnit=' + QuotedStr(CDS_Sub.fieldbyname('QtyUnit').AsString));
          SQL.Add(' group by  isnull(P_Code,''''),isnull(P_Spec,''''), isnull(BatchNo,''''),isnull(QtyUnit,'''')');
          SQL.Add(' having sum(IOQtyFlag*qty)<0   ');
//          showMessage(SQL.Text);
          OPEN;
        end;
        if ADOQueryTemp.IsEmpty = False then
        begin
          CDS_Sub.EnableControls;
          raise Exception.Create('出库数量大于入库数量不能保存！');
        end;


        CDS_Sub.Edit;
        CDS_Sub.FieldByName('BPIOID').Value := Trim(Maxno);
        CDS_Sub.Post;
        CDS_Sub.Next;
      end;
    end;

    CDS_Sub.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;

    Result := True;
  except
    Result := False;
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;

end;

procedure TfrmBSPrtDyeInEdit.TBCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmBSPrtDyeInEdit.FormDestroy(Sender: TObject);
begin
  inherited;
  frmBSPrtDyeInEdit := nil;
end;

procedure TfrmBSPrtDyeInEdit.FormShow(Sender: TObject);
var
  fsj: string;
begin
  inherited;
  ReadCxGrid(FSTKName + '入库登记', Tv1, '机物料仓库');
  with CDS_LM do
  begin
    FieldDefs.Clear;
    FieldDefs.Add('LXH', ftInteger, 0);
    FieldDefs.Add('lCode', ftString, 40);
    FieldDefs.Add('LName', ftString, 40);
    close;
    CreateDataSet;
  end;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.* ');
    sql.Add(' from BS_Product_IO A');
    sql.Add(' where BPIOID=''' + Trim(FBCId) + '''');
    Open;
  end;
  SCreateCDS(ADOQueryTemp, CDS_Sub);
  SInitCDSData(ADOQueryTemp, CDS_Sub);
//  fsj := 'select name=CJName ,Code=null from CheJian';
//  SInitCxGridComboBoxBySql(ADOQueryTemp, v1Column7, fsj, 0, True, '');
end;

procedure TfrmBSPrtDyeInEdit.TBDelClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if Trim(CDS_Sub.fieldbyname('BPIOID').AsString) <> '' then
  begin
    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;
    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        Sql.Clear;
        Sql.Add('exec P_BS_Product_In_Del ');
        Sql.Add(' @BPIOIDS=' + quotedstr(Trim(CDS_Sub.fieldbyname('BPIOID').AsString)));
        Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
        Sql.Add(',@DName=' + quotedstr(Trim(DName)));
        Open;
      end;
      if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
        raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
      ADOQueryCmd.Connection.CommitTrans;
      CDS_Sub.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    end;
  end
  else
  begin
    CDS_Sub.Delete;
  end;

end;

procedure TfrmBSPrtDyeInEdit.TBSaveClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if CDS_Sub.Locate('IOTime', null, []) = True then
  begin
    Application.MessageBox('入库时间不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('IOType', null, []) = True then
  begin
    Application.MessageBox('入库类型不能为空!', '提示', 0);
    Exit;
  end;
//  if CDS_Sub.Locate('P_Name', null, []) = True then
//  begin
//    Application.MessageBox('品名不能为空!', '提示', 0);
//    Exit;
//  end;

  if CDS_Sub.Locate('Qty', null, []) = True then
  begin
    Application.MessageBox('数量不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('QtyUnit', null, []) = True then
  begin
    Application.MessageBox('领料单位不能为空!', '提示', 0);
    Exit;
  end;

  if SaveCKData() then
  begin
    Application.MessageBox('保存成功!', '提示', 0);
    ModalResult := 1;
    Exit;
  end;
end;

procedure TfrmBSPrtDyeInEdit.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(FSTKName + '入库登记', Tv1, '机物料仓库');

end;

procedure TfrmBSPrtDyeInEdit.ToolButton2Click(Sender: TObject);
var
  excelApp, WorkBook: Variant;
  i, j, k, LX, ExcelRowCount: integer;
  maxId, FCPID, FCPName, t1, t2, t3, FFID: string;
begin

  try
    excelApp := CreateOleObject('Excel.Application');
    openDialog1.Filter := '*.CSV;*.xls';
    if opendialog1.Execute then
    begin
      WorkBook := excelApp.WorkBooks.Open(OpenDialog1.FileName);
    end
    else
      exit;
    excelApp.Visible := false;
    ExcelRowCount := WorkBook.WorkSheets[1].UsedRange.Rows.Count;
  except
    application.MessageBox('加载EXCEL错误！', '错误信息', MB_ICONERROR);
    exit;
  end;

  CDS_LM.EmptyDataSet;

  for j := 0 to Tv1.ColumnCount - 1 do
  begin
    with CDS_LM do
    begin
      Append;
      FieldByName('LCode').Value := trim(Tv1.Columns[j].DataBinding.FieldName);
      FieldByName('LName').Value := trim(Tv1.Columns[j].Caption);
      Post;
    end;
  end;

  try
    for i := 1 to 50 do
    begin
      if trim(WorkBook.WorkSheets[1].Cells[1, i].value) = '' then
        continue;
      if CDS_LM.Locate('LName', trim(WorkBook.WorkSheets[1].Cells[1, i].value), []) then
      begin
        with CDS_LM do
        begin
          Edit;
          FieldByName('LXH').Value := i;
          Post;
        end;
      end;
    end;
  except
    application.MessageBox('加载数组错误！', '错误信息', MB_ICONERROR);
    exit;
  end;

  try
    for i := 2 to ExcelRowCount do
    begin
      with CDS_Sub do
      begin
        Append;
        CDS_LM.First;
        while not CDS_LM.Eof do
        begin
          if CDS_LM.FieldByName('LXH').AsInteger > 0 then
            CDS_Sub.fieldbyname(CDS_LM.FieldByName('LCode').AsString).Value := WorkBook.WorkSheets[1].Cells[i, CDS_LM.FieldByName('LXH').AsInteger].Value;
          CDS_LM.Next;
        end;
        Post;
      end;
    end;
    WorkBook.Close;
    excelApp.Quit;
    excelApp := Unassigned;
    WorkBook := Unassigned;
  except
    WorkBook.Close;
    excelApp.Quit;
    excelApp := Unassigned;
    WorkBook := Unassigned;
    exit;
  end;

end;

procedure TfrmBSPrtDyeInEdit.Tv1Column1PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '客户';
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('StkCoNo').Value := Trim(CDS_1.fieldbyname('CoCode').AsString);
          FieldByName('StkCoName').Value := Trim(CDS_1.fieldbyname('CoAbbrName').AsString);
        end;
      end;
    end;
  finally
    frmCompanySel.Free;
  end;

end;

procedure TfrmBSPrtDyeInEdit.Tv1Column2PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
//  try
//    frmZDYHelp := TfrmZDYHelp.Create(Application);
//    with frmZDYHelp do
//    begin
//      flag := 'RHLNAME';
//      flagname := '助剂名称';
//      MainType := FSTKName;
//      fnote := True;
//      V1Note.Caption := '编号';
//      if ShowModal = 1 then
//      begin
//        with Self.CDS_Sub do
//        begin
//          Edit;
//          FieldByName('P_name').Value := Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
//          FieldByName('P_Code').Value := Trim(frmZDYHelp.ClientDataSet1.fieldbyname('Note').AsString);
//        end;
//      end;
//    end;
//  finally
//    frmZDYHelp.Free;
//  end;
  try
    frmProductInfoSel := TfrmProductInfoSel.Create(Application);
    with frmProductInfoSel do
    begin
      FSTKName := Self.FSTKName;
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('P_Code').Value := frmProductInfoSel.CDS_1.fieldbyname('P_Code').value;
          FieldByName('P_Name').Value := frmProductInfoSel.CDS_1.fieldbyname('P_Name').value;
          FieldByName('P_Spec').Value := frmProductInfoSel.CDS_1.fieldbyname('P_Type').value;   //助剂类型
          FieldByName('QtyUnit').Value := frmProductInfoSel.CDS_1.fieldbyname('TakeUnit').value;  //数量单位作为领料单位
//          FieldByName('Price').Value := frmProductInfoSel.CDS_1.fieldbyname('Price').value;
//          FieldByName('TakeUnit').Value := frmProductInfoSel.CDS_1.fieldbyname('TakeUnit').value;    //领料单位
        end;
      end;
    end;
  finally
    frmProductInfoSel.Free;
  end;
end;

procedure TfrmBSPrtDyeInEdit.v1Column14PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin

  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      FCoType := '供应商';
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('FromCoNo').Value := Trim(CDS_1.fieldbyname('CoCode').AsString);
          FieldByName('FromCoName').Value := Trim(CDS_1.fieldbyname('CoAbbrName').AsString);
        end;
      end;
    end;
  finally
    frmCompanySel.Free;
  end;

end;

procedure TfrmBSPrtDyeInEdit.v1Column5PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'StkPosition';
      flagname := '库位';
      MainType := FSTKName;
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('StkPosition').Value := Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);
        end;
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

end.

